*macro_loop_from_data.sps
*create some sample data.
DATA LIST LIST /id(F8) var1(F8).
BEGIN DATA.
1 1
1 3
1 2
2 20
2 25
3 15
3 25
END DATA.
SAVE OUTFILE='c:\temp\tempdata.sav'.
SET MPRINT=OFF.

***real job starts here***.
*use aggregate to find sum of var 1 for id 1.
AGGREGATE
 /OUTFILE=*
 /BREAK=id
 /var1_1 = SUM(var1).

* Write a command file that defines a macro using the value of var1_1  
  as the end value for the !DO loop.
DO IF id=1.
WRITE OUTFILE 'c:\temp\temp.sps' 
  /"DEFINE !LoopingMacro()"
 / "!DO !cnt=1 !TO " var1_1
 /"COMPUTE !CONCAT(var,!cnt)=!cnt."
 /"!DOEND"
 /"!ENDDEFINE.".
END IF.
EXECUTE.

*open the original data file and run the include file that defines the macro.
GET FILE='c:\temp\tempdata.sav'.
INSERT FILE= 'c:\temp\temp.sps'.

SET MPRINT=ON.
* Invoke the macro then execute transformations.
!LoopingMacro.
EXECUTE.

