* macros_import_value_labels_from_access.sps.

GET DATA 
  /TYPE=ODBC 
  /CONNECT=  'DSN=MS Access Database;'
      'DBQ=C:\examples\data\demo.mdb;'
  /SQL =  'SELECT * FROM demo;'.
SAVE OUTFILE='c:\temp\data from access.sav'.

*////////////.
DEFINE !getlab (table=!TOKENS(1) /vname=!TOKENS(1) /vlabel=!TOKENS(1))

/* table = name of MS Access table containing values and value labels  */
/* vname = name of variable whose value labels will be defined    */
/* vlabel= the access table Field Name containing the labels of !vname  */ 

GET DATA 
  /TYPE=ODBC 
  /CONNECT=  'DSN=MS Access Database;'
      'DBQ=C:\examples\data\demo.mdb;'
  /SQL =  'SELECT * '
      !QUOTE(!CONCAT("FROM [",!UNQUOTE(!table),"];")).

WRITE OUTFILE=!QUOTE(!CONCAT('c:\temp\define ',!vname,'.sps'))
  /"ADD VALUE LABELS " !QUOTE(!vname) " " !vname " '" !vlabel"'.".
EXECUTE.
!ENDDEFINE.
*///////////.

SET MPRINT=ON.
* Call macro: once for empcat and once for reside.
!getlab table =empcatlab  vname=empcat vlabel=empcatlabel.
!getlab table ='reside label' vname=reside vlabel=label.
SET MPRINT=no.

GET FILE='c:\temp\data from access.sav'.
INSERT  FILE = 'c:\temp\define empcat.sps' .
INSERT FILE = 'c:\temp\define reside.sps'.
